/*
 *  Copyright (c) 2001-2003, Jean Tessier
 *  All rights reserved.
 *  
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  
 *  	* Redistributions of source code must retain the above copyright
 *  	  notice, this list of conditions and the following disclaimer.
 *  
 *  	* Redistributions in binary form must reproduce the above copyright
 *  	  notice, this list of conditions and the following disclaimer in the
 *  	  documentation and/or other materials provided with the distribution.
 *  
 *  	* Neither the name of Jean Tessier nor the names of his contributors
 *  	  may be used to endorse or promote products derived from this software
 *  	  without specific prior written permission.
 *  
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.jeantessier.metrics;

public class NullMeasurement implements Measurement {
	public MeasurementDescriptor Descriptor() {
		return null;
	}

	public Metrics Context() {
		return null;
	}
	
	public String ShortName() {
		return null;
	}
	
	public String LongName() {
		return null;
	}

	public Number Value(){
		return null;
	}
	
	public int intValue() {
		return 0;
	}
	
	public long longValue() {
		return 0;
	}
	
	public float floatValue() {
		return 0;
	}
	
	public double doubleValue() {
		return 0;
	}

	public boolean InRange() {
		return false;
	}
	
	public void Add(Object object) {
		// Do nothing
	}
	
	public void Add(int i) {
		// Do nothing
	}
	
	public void Add(long l) {
		// Do nothing
	}
	
	public void Add(float f) {
		// Do nothing
	}
	
	public void Add(double d) {
		// Do nothing
	}

	public void Accept(MeasurementVisitor visitor) {
		// Do nothing
	}
}
